package przyklad;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.net.*;
import przyklad.serwer.operacje.*;

public class PolaczenieImpl extends UnicastRemoteObject
                            implements Polaczenie
 {
 	Properties properties = null;
 	final String dbUrl = "jdbc:odbc:katalog";
 	final String drivers = "sun.jdbc.odbc.JdbcOdbcDriver";
 	
 	public PolaczenieImpl() throws RemoteException
 	 {properties = new Properties();
 	 }
 	 
 	public synchronized Sesja polacz (String uzytkownik, 
 	              String haslo) throws RemoteException
 	 { if (properties.containsKey(uzytkownik))
 	    {   System.out.println("user");
 	    	return (SesjaImpl) properties.get(uzytkownik);
 	    }
 	   else 
 	    {
 	      SesjaImpl sesja=new SesjaImpl(drivers,dbUrl,
 	                           uzytkownik, haslo);
 	      if (sesja.otworz_baze_danych(uzytkownik,haslo))
 	       {try
 	        { Naming.rebind("Przyklad"+uzytkownik,sesja);
 	          properties.put(uzytkownik,sesja);
 	          System.out.println("Po otwarciu bazy danych");
 	          return sesja;
 	        }
 	        catch(MalformedURLException e)
 	         {System.out.println(e.getMessage());
 	          return null;
 	         }
 	       }
 	       else
 	        {return null;
 	        }		      	
 	    }
 	   } 
 	    
 	 public synchronized void rozlacz (String uzytkownik)
 	                               throws RemoteException
 	  { SesjaImpl sesja=(SesjaImpl)properties.get(uzytkownik);
 	    if (null != sesja)
 	     {sesja.zamknij_baze_danych ();
 	      properties.remove(uzytkownik);
 	    try
 	      {Naming.unbind("Przyklad"+uzytkownik);
 	      }
 	    catch(Exception e)
 	       {System.out.println(e);
 	       }
 	     }
 	  }
 }